<?php

/*Interesting pages to read
https://confluence.secutix.com/display/DOCEN/SecuTix+Standard+for+Web+Services
https://confluence.secutix.com/display/DOCEN/Catalog+API
https://confluence.secutix.com/display/DOCEN/Sales+API+test+account

*/


/* Initialize webservice with your WSDL */
$client = new SoapClient("https://mosa.demo-ws.secutix.com/tnseb/external-remoting/com.secutix.service.realtime.catalog.v1_19.CatalogService.webservice?wsdl", array('trace' => 1,'exceptions' => 0));

//Add the WS-security header
//https://stackoverflow.com/questions/953639/connecting-to-ws-security-protected-web-service-with-php

class WsseAuthHeader extends SoapHeader {

private $wss_ns = 'http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd';

function __construct($user, $pass, $ns = null) {
    if ($ns) {
        $this->wss_ns = $ns;
    }

    $auth = new stdClass();
    $auth->Username = new SoapVar($user, XSD_STRING, NULL, $this->wss_ns, NULL, $this->wss_ns); 
    $auth->Password = new SoapVar($pass, XSD_STRING, NULL, $this->wss_ns, NULL, $this->wss_ns);

    $username_token = new stdClass();
    $username_token->UsernameToken = new SoapVar($auth, SOAP_ENC_OBJECT, NULL, $this->wss_ns, 'UsernameToken', $this->wss_ns); 

    $security_sv = new SoapVar(
        new SoapVar($username_token, SOAP_ENC_OBJECT, NULL, $this->wss_ns, 'UsernameToken', $this->wss_ns),
        SOAP_ENC_OBJECT, NULL, $this->wss_ns, 'Security', $this->wss_ns);
    parent::__construct($this->wss_ns, 'Security', $security_sv, true);
}
}

// Here put the login and password of your account.
$wsse_header = new WsseAuthHeader("MOSA_B2C", "P@ssw0rd");


//set the Headers of Soap Client.
$client->__setSoapHeaders(array($wsse_header));


/* Set your parameters for the request */
$params = array(
  0
);

/* Invoke webservice method with your parameters, in this case: getLastSetupUpdate */
echo "========= Calling method getLastSetupUpdate of Catalog Service =========" . "<br/>";
try {
$response = $client->__soapCall("getLastSetupUpdate", $params);
} catch (Exception $e) {
echo "====== REQUEST HEADERS =====" ."<br/>";
    var_dump($client->__getLastRequestHeaders());
    echo "========= REQUEST ==========" . "<br/>";
    var_dump($client->__getLastRequest());
    
 

 echo 'Exception reue : ',  $e->getMessage(), "\n";
}
echo "========= RESPONSE =========" . "<br/>";
var_dump($response);
echo "<br/>";
echo "========= LAST SETUP DATE =========" . "<br/>";
$lastSetupDate = (string) $response->LastSetupUpdateResult->lastSetupUpdate;
echo $lastSetupDate;


?>